#import "AppController.h"
#import <sys/sysctl.h>
@implementation AppController

- (IBAction)letsFree:(id)sender
{
	if (r)
		free(r);
	r = NULL;
	[ramProgressBar setDoubleValue:0];
	[swapButton setEnabled:YES];
	[freeButton setEnabled:NO];
	[pourcentText setStringValue:[NSString stringWithFormat:@"0%"]];
}

- (IBAction)letsSwap:(id)sender
{
	r=malloc(ramToAllocate*1024*256*sizeof(int)); // we assume sizeof(int)= 4 bytes
	if (!r)
		NSLog(@"Not enough memory");
	else {
		[freeButton setEnabled:NO];
		[swapButton setEnabled:NO];
		[NSThread detachNewThreadSelector:@selector(fillWithZero:) toTarget:self withObject:nil];
	}
}

- (void)fillWithZero:(id)anObject
{
	// create new autorelease pool for the thread
	NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
	int i;
	for(i=0;i<ramToAllocate*1024*256;i++){
		r[i]=0;
		if (!(i%(1024*256))){
			[ramProgressBar setDoubleValue:(double)i];
			[pourcentText setStringValue:[NSString stringWithFormat:@"%d",(long)(i/(ramToAllocate*10.24*256))]];
		}
	}
	[ramProgressBar setDoubleValue:(double)i]; // fill the bar if the above condition stop before
	[pourcentText setStringValue:[NSString stringWithFormat:@"%d",(long)(i/(ramToAllocate*10.24*256))]];
	[freeButton setEnabled:YES];
	// release the autorelease pool
	[pool release];
}

- (IBAction)setAllocationValue:(id)sender
{
	if (!r){ // if no memory is currently allocated
		ramToAllocate = [sender floatValue];
		//NSLog(@"RAM to allocate : %d",ramToAllocate);

		//[ramProgressBar setMinValue:(double)0];
		[ramProgressBar setMaxValue:(double)ramToAllocate*1024*256];
		[ramProgressBar setDoubleValue:(double)0];
		[allocateText setStringValue:[NSString stringWithFormat:@"Allocation: %d MB of RAM",ramToAllocate]];
		[pourcentText setStringValue:[NSString stringWithFormat:@"0%"]];
	}
	else {
		NSLog(@"Free before !");
		[ramSlider setFloatValue:(double)ramToAllocate];
	}
}

- (IBAction)setSlider:(id)sender
{
	if ([markerValue state])
		[ramSlider setAllowsTickMarkValuesOnly:YES];
	else
		[ramSlider setAllowsTickMarkValuesOnly:NO];		
}

-(void)awakeFromNib
{
	int mib[2], my_memory;
	size_t len;

	mib[0] = CTL_HW;
	mib[1] = HW_PHYSMEM;
	len = sizeof(my_memory);
	sysctl(mib, 2, &my_memory, &len, NULL, 0);

	my_memory = my_memory/(1024*1024);
	[ramText setStringValue:[NSString stringWithFormat:@"Total: %d MB of RAM",my_memory]];

	[ramSlider setMinValue:(double)0];
	[ramSlider setMaxValue:(double)my_memory];

	r = NULL;

	ramToAllocate = my_memory/2;
	[ramSlider setFloatValue:ramToAllocate];
	NSLog(@"RAM to allocate : %d",ramToAllocate);
	[allocateText setStringValue:[NSString stringWithFormat:@"Allocation: %d MB of RAM",ramToAllocate]];
	[pourcentText setStringValue:[NSString stringWithFormat:@"0%"]];
	[ramProgressBar setMinValue:(double)0];
	[ramProgressBar setMaxValue:(double)ramToAllocate*1024*256];
	[ramProgressBar setDoubleValue:(double)0];
	[freeButton setEnabled:NO]; // no need to free

	[markerValue setState:1];
	[ramSlider setAllowsTickMarkValuesOnly:YES];
}
//since this is a single window app, quit when window closes
-(BOOL)applicationShouldTerminateAfterLastWindowClosed:(NSApplication *)theApplication
{
	return YES;
}
@end
